<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>SSLSocketFactory xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/http/conn/ssl/SSLSocketFactory.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.conn.ssl;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.ThreadSafe;
<a class="jxr_linenumber" name="32" href="#32">32</a>  
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.ConnectTimeoutException;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.HttpInetSocketAddress;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.scheme.HostNameResolver;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.scheme.LayeredSchemeSocketFactory;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.scheme.LayeredSocketFactory;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.scheme.SchemeLayeredSocketFactory;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpConnectionParams;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="41" href="#41">41</a>  
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.KeyManager;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.KeyManagerFactory;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.SSLContext;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.SSLSocket;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.TrustManager;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.TrustManagerFactory;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.X509TrustManager;
<a class="jxr_linenumber" name="49" href="#49">49</a>  
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> java.io.File;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> java.io.FileInputStream;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> java.net.InetAddress;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> java.net.InetSocketAddress;
<a class="jxr_linenumber" name="55" href="#55">55</a>  <strong class="jxr_keyword">import</strong> java.net.Socket;
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">import</strong> java.net.SocketTimeoutException;
<a class="jxr_linenumber" name="57" href="#57">57</a>  <strong class="jxr_keyword">import</strong> java.net.UnknownHostException;
<a class="jxr_linenumber" name="58" href="#58">58</a>  <strong class="jxr_keyword">import</strong> java.security.KeyManagementException;
<a class="jxr_linenumber" name="59" href="#59">59</a>  <strong class="jxr_keyword">import</strong> java.security.KeyStore;
<a class="jxr_linenumber" name="60" href="#60">60</a>  <strong class="jxr_keyword">import</strong> java.security.KeyStoreException;
<a class="jxr_linenumber" name="61" href="#61">61</a>  <strong class="jxr_keyword">import</strong> java.security.NoSuchAlgorithmException;
<a class="jxr_linenumber" name="62" href="#62">62</a>  <strong class="jxr_keyword">import</strong> java.security.NoSuchProviderException;
<a class="jxr_linenumber" name="63" href="#63">63</a>  <strong class="jxr_keyword">import</strong> java.security.SecureRandom;
<a class="jxr_linenumber" name="64" href="#64">64</a>  <strong class="jxr_keyword">import</strong> java.security.UnrecoverableKeyException;
<a class="jxr_linenumber" name="65" href="#65">65</a>  <strong class="jxr_keyword">import</strong> java.security.cert.CertificateException;
<a class="jxr_linenumber" name="66" href="#66">66</a>  
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment"> * Layered socket factory for TLS/SSL connections.</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment"> * SSLSocketFactory can be used to validate the identity of the HTTPS server against a list of</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment"> * trusted certificates and to authenticate to the HTTPS server using a private key.</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  <em class="jxr_javadoccomment"> * SSLSocketFactory will enable server authentication when supplied with</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>  <em class="jxr_javadoccomment"> * a {@link KeyStore trust-store} file containing one or several trusted certificates. The client</em>
<a class="jxr_linenumber" name="75" href="#75">75</a>  <em class="jxr_javadoccomment"> * secure socket will reject the connection during the SSL session handshake if the target HTTPS</em>
<a class="jxr_linenumber" name="76" href="#76">76</a>  <em class="jxr_javadoccomment"> * server attempts to authenticate itself with a non-trusted certificate.</em>
<a class="jxr_linenumber" name="77" href="#77">77</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>  <em class="jxr_javadoccomment"> * Use JDK keytool utility to import a trusted certificate and generate a trust-store file:</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment"> *    &lt;pre&gt;</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>  <em class="jxr_javadoccomment"> *     keytool -import -alias "my server cert" -file server.crt -keystore my.truststore</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>  <em class="jxr_javadoccomment"> *    &lt;/pre&gt;</em>
<a class="jxr_linenumber" name="82" href="#82">82</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="83" href="#83">83</a>  <em class="jxr_javadoccomment"> * In special cases the standard trust verification process can be bypassed by using a custom</em>
<a class="jxr_linenumber" name="84" href="#84">84</a>  <em class="jxr_javadoccomment"> * {@link TrustStrategy}. This interface is primarily intended for allowing self-signed</em>
<a class="jxr_linenumber" name="85" href="#85">85</a>  <em class="jxr_javadoccomment"> * certificates to be accepted as trusted without having to add them to the trust-store file.</em>
<a class="jxr_linenumber" name="86" href="#86">86</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>  <em class="jxr_javadoccomment"> * The following parameters can be used to customize the behavior of this</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment"> * class:</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>  <em class="jxr_javadoccomment"> * &lt;ul&gt;</em>
<a class="jxr_linenumber" name="90" href="#90">90</a>  <em class="jxr_javadoccomment"> *  &lt;li&gt;{@link org.apache.http.params.CoreConnectionPNames#CONNECTION_TIMEOUT}&lt;/li&gt;</em>
<a class="jxr_linenumber" name="91" href="#91">91</a>  <em class="jxr_javadoccomment"> *  &lt;li&gt;{@link org.apache.http.params.CoreConnectionPNames#SO_TIMEOUT}&lt;/li&gt;</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>  <em class="jxr_javadoccomment"> *  &lt;li&gt;{@link org.apache.http.params.CoreConnectionPNames#SO_REUSEADDR}&lt;/li&gt;</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>  <em class="jxr_javadoccomment"> * &lt;/ul&gt;</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment"> * SSLSocketFactory will enable client authentication when supplied with</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  <em class="jxr_javadoccomment"> * a {@link KeyStore key-store} file containing a private key/public certificate</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>  <em class="jxr_javadoccomment"> * pair. The client secure socket will use the private key to authenticate</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <em class="jxr_javadoccomment"> * itself to the target HTTPS server during the SSL session handshake if</em>
<a class="jxr_linenumber" name="99" href="#99">99</a>  <em class="jxr_javadoccomment"> * requested to do so by the server.</em>
<a class="jxr_linenumber" name="100" href="#100">100</a> <em class="jxr_javadoccomment"> * The target HTTPS server will in its turn verify the certificate presented</em>
<a class="jxr_linenumber" name="101" href="#101">101</a> <em class="jxr_javadoccomment"> * by the client in order to establish client's authenticity</em>
<a class="jxr_linenumber" name="102" href="#102">102</a> <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <em class="jxr_javadoccomment"> * Use the following sequence of actions to generate a key-store file</em>
<a class="jxr_linenumber" name="104" href="#104">104</a> <em class="jxr_javadoccomment"> * &lt;/p&gt;</em>
<a class="jxr_linenumber" name="105" href="#105">105</a> <em class="jxr_javadoccomment"> *   &lt;ul&gt;</em>
<a class="jxr_linenumber" name="106" href="#106">106</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="107" href="#107">107</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="108" href="#108">108</a> <em class="jxr_javadoccomment"> *      Use JDK keytool utility to generate a new key</em>
<a class="jxr_linenumber" name="109" href="#109">109</a> <em class="jxr_javadoccomment"> *      &lt;pre&gt;keytool -genkey -v -alias "my client key" -validity 365 -keystore my.keystore&lt;/pre&gt;</em>
<a class="jxr_linenumber" name="110" href="#110">110</a> <em class="jxr_javadoccomment"> *      For simplicity use the same password for the key as that of the key-store</em>
<a class="jxr_linenumber" name="111" href="#111">111</a> <em class="jxr_javadoccomment"> *      &lt;/p&gt;</em>
<a class="jxr_linenumber" name="112" href="#112">112</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="113" href="#113">113</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="114" href="#114">114</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="115" href="#115">115</a> <em class="jxr_javadoccomment"> *      Issue a certificate signing request (CSR)</em>
<a class="jxr_linenumber" name="116" href="#116">116</a> <em class="jxr_javadoccomment"> *      &lt;pre&gt;keytool -certreq -alias "my client key" -file mycertreq.csr -keystore my.keystore&lt;/pre&gt;</em>
<a class="jxr_linenumber" name="117" href="#117">117</a> <em class="jxr_javadoccomment"> *     &lt;/p&gt;</em>
<a class="jxr_linenumber" name="118" href="#118">118</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="119" href="#119">119</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="120" href="#120">120</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="121" href="#121">121</a> <em class="jxr_javadoccomment"> *      Send the certificate request to the trusted Certificate Authority for signature.</em>
<a class="jxr_linenumber" name="122" href="#122">122</a> <em class="jxr_javadoccomment"> *      One may choose to act as her own CA and sign the certificate request using a PKI</em>
<a class="jxr_linenumber" name="123" href="#123">123</a> <em class="jxr_javadoccomment"> *      tool, such as OpenSSL.</em>
<a class="jxr_linenumber" name="124" href="#124">124</a> <em class="jxr_javadoccomment"> *      &lt;/p&gt;</em>
<a class="jxr_linenumber" name="125" href="#125">125</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="126" href="#126">126</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="127" href="#127">127</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> <em class="jxr_javadoccomment"> *       Import the trusted CA root certificate</em>
<a class="jxr_linenumber" name="129" href="#129">129</a> <em class="jxr_javadoccomment"> *       &lt;pre&gt;keytool -import -alias "my trusted ca" -file caroot.crt -keystore my.keystore&lt;/pre&gt;</em>
<a class="jxr_linenumber" name="130" href="#130">130</a> <em class="jxr_javadoccomment"> *      &lt;/p&gt;</em>
<a class="jxr_linenumber" name="131" href="#131">131</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="132" href="#132">132</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="133" href="#133">133</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="134" href="#134">134</a> <em class="jxr_javadoccomment"> *       Import the PKCS#7 file containg the complete certificate chain</em>
<a class="jxr_linenumber" name="135" href="#135">135</a> <em class="jxr_javadoccomment"> *       &lt;pre&gt;keytool -import -alias "my client key" -file mycert.p7 -keystore my.keystore&lt;/pre&gt;</em>
<a class="jxr_linenumber" name="136" href="#136">136</a> <em class="jxr_javadoccomment"> *      &lt;/p&gt;</em>
<a class="jxr_linenumber" name="137" href="#137">137</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="138" href="#138">138</a> <em class="jxr_javadoccomment"> *     &lt;li&gt;</em>
<a class="jxr_linenumber" name="139" href="#139">139</a> <em class="jxr_javadoccomment"> *      &lt;p&gt;</em>
<a class="jxr_linenumber" name="140" href="#140">140</a> <em class="jxr_javadoccomment"> *       Verify the content the resultant keystore file</em>
<a class="jxr_linenumber" name="141" href="#141">141</a> <em class="jxr_javadoccomment"> *       &lt;pre&gt;keytool -list -v -keystore my.keystore&lt;/pre&gt;</em>
<a class="jxr_linenumber" name="142" href="#142">142</a> <em class="jxr_javadoccomment"> *      &lt;/p&gt;</em>
<a class="jxr_linenumber" name="143" href="#143">143</a> <em class="jxr_javadoccomment"> *     &lt;/li&gt;</em>
<a class="jxr_linenumber" name="144" href="#144">144</a> <em class="jxr_javadoccomment"> *   &lt;/ul&gt;</em>
<a class="jxr_linenumber" name="145" href="#145">145</a> <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="146" href="#146">146</a> <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="147" href="#147">147</a> <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="148" href="#148">148</a> @SuppressWarnings(<span class="jxr_string">"deprecation"</span>)
<a class="jxr_linenumber" name="149" href="#149">149</a> @ThreadSafe
<a class="jxr_linenumber" name="150" href="#150">150</a> <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a> <strong class="jxr_keyword">implements</strong> SchemeLayeredSocketFactory,
<a class="jxr_linenumber" name="151" href="#151">151</a>                                          LayeredSchemeSocketFactory, <a href="../../../../../org/apache/http/conn/scheme/LayeredSocketFactory.html">LayeredSocketFactory</a> {
<a class="jxr_linenumber" name="152" href="#152">152</a> 
<a class="jxr_linenumber" name="153" href="#153">153</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String TLS   = <span class="jxr_string">"TLS"</span>;
<a class="jxr_linenumber" name="154" href="#154">154</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SSL   = <span class="jxr_string">"SSL"</span>;
<a class="jxr_linenumber" name="155" href="#155">155</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SSLV2 = <span class="jxr_string">"SSLv2"</span>;
<a class="jxr_linenumber" name="156" href="#156">156</a> 
<a class="jxr_linenumber" name="157" href="#157">157</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> ALLOW_ALL_HOSTNAME_VERIFIER
<a class="jxr_linenumber" name="158" href="#158">158</a>         = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/AllowAllHostnameVerifier.html">AllowAllHostnameVerifier</a>();
<a class="jxr_linenumber" name="159" href="#159">159</a> 
<a class="jxr_linenumber" name="160" href="#160">160</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> BROWSER_COMPATIBLE_HOSTNAME_VERIFIER
<a class="jxr_linenumber" name="161" href="#161">161</a>         = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/BrowserCompatHostnameVerifier.html">BrowserCompatHostnameVerifier</a>();
<a class="jxr_linenumber" name="162" href="#162">162</a> 
<a class="jxr_linenumber" name="163" href="#163">163</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> STRICT_HOSTNAME_VERIFIER
<a class="jxr_linenumber" name="164" href="#164">164</a>         = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/StrictHostnameVerifier.html">StrictHostnameVerifier</a>();
<a class="jxr_linenumber" name="165" href="#165">165</a> 
<a class="jxr_linenumber" name="166" href="#166">166</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">char</strong>[] EMPTY_PASSWORD = <span class="jxr_string">""</span>.toCharArray();
<a class="jxr_linenumber" name="167" href="#167">167</a> 
<a class="jxr_linenumber" name="168" href="#168">168</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="169" href="#169">169</a> <em class="jxr_javadoccomment">     * Gets the default factory, which uses the default JSSE settings for initializing</em>
<a class="jxr_linenumber" name="170" href="#170">170</a> <em class="jxr_javadoccomment">     * the SSL context.</em>
<a class="jxr_linenumber" name="171" href="#171">171</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="172" href="#172">172</a> <em class="jxr_javadoccomment">     * @return the default SSL socket factory</em>
<a class="jxr_linenumber" name="173" href="#173">173</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="174" href="#174">174</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a> getSocketFactory() <strong class="jxr_keyword">throws</strong> SSLInitializationException {
<a class="jxr_linenumber" name="175" href="#175">175</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(createDefaultSSLContext());
<a class="jxr_linenumber" name="176" href="#176">176</a>     }
<a class="jxr_linenumber" name="177" href="#177">177</a> 
<a class="jxr_linenumber" name="178" href="#178">178</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="179" href="#179">179</a> <em class="jxr_javadoccomment">     * Gets the default factory, which uses system properties for initializing the SSL context</em>
<a class="jxr_linenumber" name="180" href="#180">180</a> <em class="jxr_javadoccomment">     * as described in</em>
<a class="jxr_linenumber" name="181" href="#181">181</a> <em class="jxr_javadoccomment">     * &lt;a href="<a href="http://docs.oracle.com/javase/1.5.0/docs/guide/security/jsse/JSSERefGuide.html" target="alexandria_uri">http://docs.oracle.com/javase/1.5.0/docs/guide/security/jsse/JSSERefGuide.html</a>"&gt;</em>
<a class="jxr_linenumber" name="182" href="#182">182</a> <em class="jxr_javadoccomment">     * "JavaTM Secure Socket Extension (JSSE) Reference Guide for the JavaTM 2 Platform</em>
<a class="jxr_linenumber" name="183" href="#183">183</a> <em class="jxr_javadoccomment">     * Standard Edition 5&lt;/a&gt;</em>
<a class="jxr_linenumber" name="184" href="#184">184</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="185" href="#185">185</a> <em class="jxr_javadoccomment">     * The following system properties are taken into account by this method:</em>
<a class="jxr_linenumber" name="186" href="#186">186</a> <em class="jxr_javadoccomment">     * &lt;ul&gt;</em>
<a class="jxr_linenumber" name="187" href="#187">187</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;ssl.TrustManagerFactory.algorithm&lt;/li&gt;</em>
<a class="jxr_linenumber" name="188" href="#188">188</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.trustStoreType&lt;/li&gt;</em>
<a class="jxr_linenumber" name="189" href="#189">189</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.trustStore&lt;/li&gt;</em>
<a class="jxr_linenumber" name="190" href="#190">190</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.trustStoreProvider&lt;/li&gt;</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.trustStorePassword&lt;/li&gt;</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;java.home&lt;/li&gt;</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;ssl.KeyManagerFactory.algorithm&lt;/li&gt;</em>
<a class="jxr_linenumber" name="194" href="#194">194</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.keyStoreType&lt;/li&gt;</em>
<a class="jxr_linenumber" name="195" href="#195">195</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.keyStore&lt;/li&gt;</em>
<a class="jxr_linenumber" name="196" href="#196">196</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.keyStoreProvider&lt;/li&gt;</em>
<a class="jxr_linenumber" name="197" href="#197">197</a> <em class="jxr_javadoccomment">     *  &lt;li&gt;javax.net.ssl.keyStorePassword&lt;/li&gt;</em>
<a class="jxr_linenumber" name="198" href="#198">198</a> <em class="jxr_javadoccomment">     * &lt;/ul&gt;</em>
<a class="jxr_linenumber" name="199" href="#199">199</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="200" href="#200">200</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="201" href="#201">201</a> <em class="jxr_javadoccomment">     * @return the system SSL socket factory</em>
<a class="jxr_linenumber" name="202" href="#202">202</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="203" href="#203">203</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a> getSystemSocketFactory() <strong class="jxr_keyword">throws</strong> SSLInitializationException {
<a class="jxr_linenumber" name="204" href="#204">204</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(createSystemSSLContext());
<a class="jxr_linenumber" name="205" href="#205">205</a>     }
<a class="jxr_linenumber" name="206" href="#206">206</a> 
<a class="jxr_linenumber" name="207" href="#207">207</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> javax.net.ssl.SSLSocketFactory socketfactory;
<a class="jxr_linenumber" name="208" href="#208">208</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/scheme/HostNameResolver.html">HostNameResolver</a> nameResolver;
<a class="jxr_linenumber" name="209" href="#209">209</a>     <em class="jxr_comment">// TODO: make final</em>
<a class="jxr_linenumber" name="210" href="#210">210</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier;
<a class="jxr_linenumber" name="211" href="#211">211</a> 
<a class="jxr_linenumber" name="212" href="#212">212</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> SSLContext createSSLContext(
<a class="jxr_linenumber" name="213" href="#213">213</a>             String algorithm,
<a class="jxr_linenumber" name="214" href="#214">214</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="215" href="#215">215</a>             <strong class="jxr_keyword">final</strong> String keystorePassword,
<a class="jxr_linenumber" name="216" href="#216">216</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore,
<a class="jxr_linenumber" name="217" href="#217">217</a>             <strong class="jxr_keyword">final</strong> SecureRandom random,
<a class="jxr_linenumber" name="218" href="#218">218</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/TrustStrategy.html">TrustStrategy</a> trustStrategy)
<a class="jxr_linenumber" name="219" href="#219">219</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyStoreException, UnrecoverableKeyException, KeyManagementException {
<a class="jxr_linenumber" name="220" href="#220">220</a>         <strong class="jxr_keyword">if</strong> (algorithm == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="221" href="#221">221</a>             algorithm = TLS;
<a class="jxr_linenumber" name="222" href="#222">222</a>         }
<a class="jxr_linenumber" name="223" href="#223">223</a>         KeyManagerFactory kmfactory = KeyManagerFactory.getInstance(
<a class="jxr_linenumber" name="224" href="#224">224</a>                 KeyManagerFactory.getDefaultAlgorithm());
<a class="jxr_linenumber" name="225" href="#225">225</a>         kmfactory.init(keystore, keystorePassword != <strong class="jxr_keyword">null</strong> ? keystorePassword.toCharArray(): <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="226" href="#226">226</a>         KeyManager[] keymanagers =  kmfactory.getKeyManagers();
<a class="jxr_linenumber" name="227" href="#227">227</a>         TrustManagerFactory tmfactory = TrustManagerFactory.getInstance(
<a class="jxr_linenumber" name="228" href="#228">228</a>                 TrustManagerFactory.getDefaultAlgorithm());
<a class="jxr_linenumber" name="229" href="#229">229</a>         tmfactory.init(truststore);
<a class="jxr_linenumber" name="230" href="#230">230</a>         TrustManager[] trustmanagers = tmfactory.getTrustManagers();
<a class="jxr_linenumber" name="231" href="#231">231</a>         <strong class="jxr_keyword">if</strong> (trustmanagers != <strong class="jxr_keyword">null</strong> &amp;&amp; trustStrategy != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="232" href="#232">232</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; trustmanagers.length; i++) {
<a class="jxr_linenumber" name="233" href="#233">233</a>                 TrustManager tm = trustmanagers[i];
<a class="jxr_linenumber" name="234" href="#234">234</a>                 <strong class="jxr_keyword">if</strong> (tm instanceof X509TrustManager) {
<a class="jxr_linenumber" name="235" href="#235">235</a>                     trustmanagers[i] = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/TrustManagerDecorator.html">TrustManagerDecorator</a>(
<a class="jxr_linenumber" name="236" href="#236">236</a>                             (X509TrustManager) tm, trustStrategy);
<a class="jxr_linenumber" name="237" href="#237">237</a>                 }
<a class="jxr_linenumber" name="238" href="#238">238</a>             }
<a class="jxr_linenumber" name="239" href="#239">239</a>         }
<a class="jxr_linenumber" name="240" href="#240">240</a> 
<a class="jxr_linenumber" name="241" href="#241">241</a>         SSLContext sslcontext = SSLContext.getInstance(algorithm);
<a class="jxr_linenumber" name="242" href="#242">242</a>         sslcontext.init(keymanagers, trustmanagers, random);
<a class="jxr_linenumber" name="243" href="#243">243</a>         <strong class="jxr_keyword">return</strong> sslcontext;
<a class="jxr_linenumber" name="244" href="#244">244</a>     }
<a class="jxr_linenumber" name="245" href="#245">245</a>     
<a class="jxr_linenumber" name="246" href="#246">246</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> SSLContext createSystemSSLContext(
<a class="jxr_linenumber" name="247" href="#247">247</a>             String algorithm,
<a class="jxr_linenumber" name="248" href="#248">248</a>             <strong class="jxr_keyword">final</strong> SecureRandom random) <strong class="jxr_keyword">throws</strong> IOException, NoSuchAlgorithmException, NoSuchProviderException,
<a class="jxr_linenumber" name="249" href="#249">249</a>             KeyStoreException, CertificateException, UnrecoverableKeyException, KeyManagementException {
<a class="jxr_linenumber" name="250" href="#250">250</a>         <strong class="jxr_keyword">if</strong> (algorithm == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="251" href="#251">251</a>             algorithm = TLS;
<a class="jxr_linenumber" name="252" href="#252">252</a>         }
<a class="jxr_linenumber" name="253" href="#253">253</a>         TrustManagerFactory tmfactory = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="254" href="#254">254</a> 
<a class="jxr_linenumber" name="255" href="#255">255</a>         String trustAlgorithm = System.getProperty(<span class="jxr_string">"ssl.TrustManagerFactory.algorithm"</span>);
<a class="jxr_linenumber" name="256" href="#256">256</a>         <strong class="jxr_keyword">if</strong> (trustAlgorithm == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="257" href="#257">257</a>             trustAlgorithm = TrustManagerFactory.getDefaultAlgorithm();
<a class="jxr_linenumber" name="258" href="#258">258</a>         }
<a class="jxr_linenumber" name="259" href="#259">259</a>         String trustStoreType = System.getProperty(<span class="jxr_string">"javax.net.ssl.trustStoreType"</span>);
<a class="jxr_linenumber" name="260" href="#260">260</a>         <strong class="jxr_keyword">if</strong> (trustStoreType == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="261" href="#261">261</a>             trustStoreType = KeyStore.getDefaultType();
<a class="jxr_linenumber" name="262" href="#262">262</a>         }
<a class="jxr_linenumber" name="263" href="#263">263</a>         <strong class="jxr_keyword">if</strong> (<span class="jxr_string">"none"</span>.equalsIgnoreCase(trustStoreType)) {
<a class="jxr_linenumber" name="264" href="#264">264</a>             tmfactory = TrustManagerFactory.getInstance(trustAlgorithm);
<a class="jxr_linenumber" name="265" href="#265">265</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="266" href="#266">266</a>             File trustStoreFile = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="267" href="#267">267</a>             String s = System.getProperty(<span class="jxr_string">"javax.net.ssl.trustStore"</span>);
<a class="jxr_linenumber" name="268" href="#268">268</a>             <strong class="jxr_keyword">if</strong> (s != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="269" href="#269">269</a>                 trustStoreFile = <strong class="jxr_keyword">new</strong> File(s);
<a class="jxr_linenumber" name="270" href="#270">270</a>                 tmfactory = TrustManagerFactory.getInstance(trustAlgorithm);
<a class="jxr_linenumber" name="271" href="#271">271</a>                 String trustStoreProvider = System.getProperty(<span class="jxr_string">"javax.net.ssl.trustStoreProvider"</span>);
<a class="jxr_linenumber" name="272" href="#272">272</a>                 KeyStore trustStore;
<a class="jxr_linenumber" name="273" href="#273">273</a>                 <strong class="jxr_keyword">if</strong> (trustStoreProvider != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="274" href="#274">274</a>                     trustStore = KeyStore.getInstance(trustStoreType, trustStoreProvider);
<a class="jxr_linenumber" name="275" href="#275">275</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="276" href="#276">276</a>                     trustStore = KeyStore.getInstance(trustStoreType);
<a class="jxr_linenumber" name="277" href="#277">277</a>                 }
<a class="jxr_linenumber" name="278" href="#278">278</a>                 String trustStorePassword = System.getProperty(<span class="jxr_string">"javax.net.ssl.trustStorePassword"</span>);
<a class="jxr_linenumber" name="279" href="#279">279</a>                 FileInputStream instream = <strong class="jxr_keyword">new</strong> FileInputStream(trustStoreFile);
<a class="jxr_linenumber" name="280" href="#280">280</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="281" href="#281">281</a>                     trustStore.load(instream, trustStorePassword != <strong class="jxr_keyword">null</strong> ?
<a class="jxr_linenumber" name="282" href="#282">282</a>                             trustStorePassword.toCharArray() : EMPTY_PASSWORD);
<a class="jxr_linenumber" name="283" href="#283">283</a>                 } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="284" href="#284">284</a>                     instream.close();
<a class="jxr_linenumber" name="285" href="#285">285</a>                 }
<a class="jxr_linenumber" name="286" href="#286">286</a>                 tmfactory.init(trustStore);
<a class="jxr_linenumber" name="287" href="#287">287</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="288" href="#288">288</a>                 File javaHome = <strong class="jxr_keyword">new</strong> File(System.getProperty(<span class="jxr_string">"java.home"</span>));
<a class="jxr_linenumber" name="289" href="#289">289</a>                 File file = <strong class="jxr_keyword">new</strong> File(javaHome, <span class="jxr_string">"lib/security/jssecacerts"</span>);
<a class="jxr_linenumber" name="290" href="#290">290</a>                 <strong class="jxr_keyword">if</strong> (!file.exists()) {
<a class="jxr_linenumber" name="291" href="#291">291</a>                     file = <strong class="jxr_keyword">new</strong> File(javaHome, <span class="jxr_string">"lib/security/cacerts"</span>);
<a class="jxr_linenumber" name="292" href="#292">292</a>                     trustStoreFile = file;
<a class="jxr_linenumber" name="293" href="#293">293</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="294" href="#294">294</a>                     trustStoreFile = file;
<a class="jxr_linenumber" name="295" href="#295">295</a>                 }
<a class="jxr_linenumber" name="296" href="#296">296</a>                 tmfactory = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
<a class="jxr_linenumber" name="297" href="#297">297</a>                 KeyStore trustStore = KeyStore.getInstance(KeyStore.getDefaultType());
<a class="jxr_linenumber" name="298" href="#298">298</a>                 String trustStorePassword = System.getProperty(<span class="jxr_string">"javax.net.ssl.trustStorePassword"</span>);
<a class="jxr_linenumber" name="299" href="#299">299</a>                 FileInputStream instream = <strong class="jxr_keyword">new</strong> FileInputStream(trustStoreFile);
<a class="jxr_linenumber" name="300" href="#300">300</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="301" href="#301">301</a>                     trustStore.load(instream, trustStorePassword != <strong class="jxr_keyword">null</strong> ? trustStorePassword.toCharArray() : <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="302" href="#302">302</a>                 } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="303" href="#303">303</a>                     instream.close();
<a class="jxr_linenumber" name="304" href="#304">304</a>                 }
<a class="jxr_linenumber" name="305" href="#305">305</a>                 tmfactory.init(trustStore);
<a class="jxr_linenumber" name="306" href="#306">306</a>             }
<a class="jxr_linenumber" name="307" href="#307">307</a>         }
<a class="jxr_linenumber" name="308" href="#308">308</a> 
<a class="jxr_linenumber" name="309" href="#309">309</a>         KeyManagerFactory kmfactory = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="310" href="#310">310</a>         String keyAlgorithm = System.getProperty(<span class="jxr_string">"ssl.KeyManagerFactory.algorithm"</span>);
<a class="jxr_linenumber" name="311" href="#311">311</a>         <strong class="jxr_keyword">if</strong> (keyAlgorithm == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="312" href="#312">312</a>             keyAlgorithm = KeyManagerFactory.getDefaultAlgorithm();
<a class="jxr_linenumber" name="313" href="#313">313</a>         }
<a class="jxr_linenumber" name="314" href="#314">314</a>         String keyStoreType = System.getProperty(<span class="jxr_string">"javax.net.ssl.keyStoreType"</span>);
<a class="jxr_linenumber" name="315" href="#315">315</a>         <strong class="jxr_keyword">if</strong> (keyStoreType == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="316" href="#316">316</a>             keyStoreType = KeyStore.getDefaultType();
<a class="jxr_linenumber" name="317" href="#317">317</a>         }
<a class="jxr_linenumber" name="318" href="#318">318</a>         <strong class="jxr_keyword">if</strong> (<span class="jxr_string">"none"</span>.equalsIgnoreCase(keyStoreType)) {
<a class="jxr_linenumber" name="319" href="#319">319</a>             kmfactory = KeyManagerFactory.getInstance(keyAlgorithm);
<a class="jxr_linenumber" name="320" href="#320">320</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="321" href="#321">321</a>             File keyStoreFile = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="322" href="#322">322</a>             String s = System.getProperty(<span class="jxr_string">"javax.net.ssl.keyStore"</span>);
<a class="jxr_linenumber" name="323" href="#323">323</a>             <strong class="jxr_keyword">if</strong> (s != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="324" href="#324">324</a>                 keyStoreFile = <strong class="jxr_keyword">new</strong> File(s);
<a class="jxr_linenumber" name="325" href="#325">325</a>             }
<a class="jxr_linenumber" name="326" href="#326">326</a>             <strong class="jxr_keyword">if</strong> (keyStoreFile != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="327" href="#327">327</a>                 kmfactory = KeyManagerFactory.getInstance(keyAlgorithm);
<a class="jxr_linenumber" name="328" href="#328">328</a>                 String keyStoreProvider = System.getProperty(<span class="jxr_string">"javax.net.ssl.keyStoreProvider"</span>);
<a class="jxr_linenumber" name="329" href="#329">329</a>                 KeyStore keyStore;
<a class="jxr_linenumber" name="330" href="#330">330</a>                 <strong class="jxr_keyword">if</strong> (keyStoreProvider != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="331" href="#331">331</a>                     keyStore = KeyStore.getInstance(keyStoreType, keyStoreProvider);
<a class="jxr_linenumber" name="332" href="#332">332</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="333" href="#333">333</a>                     keyStore = KeyStore.getInstance(keyStoreType);
<a class="jxr_linenumber" name="334" href="#334">334</a>                 }
<a class="jxr_linenumber" name="335" href="#335">335</a>                 String keyStorePassword = System.getProperty(<span class="jxr_string">"javax.net.ssl.keyStorePassword"</span>);
<a class="jxr_linenumber" name="336" href="#336">336</a>                 FileInputStream instream = <strong class="jxr_keyword">new</strong> FileInputStream(keyStoreFile);
<a class="jxr_linenumber" name="337" href="#337">337</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="338" href="#338">338</a>                     keyStore.load(instream, keyStorePassword != <strong class="jxr_keyword">null</strong> ?
<a class="jxr_linenumber" name="339" href="#339">339</a>                             keyStorePassword.toCharArray() : EMPTY_PASSWORD);
<a class="jxr_linenumber" name="340" href="#340">340</a>                 } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="341" href="#341">341</a>                     instream.close();
<a class="jxr_linenumber" name="342" href="#342">342</a>                 }
<a class="jxr_linenumber" name="343" href="#343">343</a>                 kmfactory.init(keyStore, keyStorePassword != <strong class="jxr_keyword">null</strong> ?
<a class="jxr_linenumber" name="344" href="#344">344</a>                         keyStorePassword.toCharArray() : EMPTY_PASSWORD);
<a class="jxr_linenumber" name="345" href="#345">345</a>             }
<a class="jxr_linenumber" name="346" href="#346">346</a>         }
<a class="jxr_linenumber" name="347" href="#347">347</a> 
<a class="jxr_linenumber" name="348" href="#348">348</a>         SSLContext sslcontext = SSLContext.getInstance(algorithm);
<a class="jxr_linenumber" name="349" href="#349">349</a>         sslcontext.init(
<a class="jxr_linenumber" name="350" href="#350">350</a>                 kmfactory != <strong class="jxr_keyword">null</strong> ? kmfactory.getKeyManagers() : <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="351" href="#351">351</a>                 tmfactory != <strong class="jxr_keyword">null</strong> ? tmfactory.getTrustManagers() : <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="352" href="#352">352</a>                 random);
<a class="jxr_linenumber" name="353" href="#353">353</a>         <strong class="jxr_keyword">return</strong> sslcontext;
<a class="jxr_linenumber" name="354" href="#354">354</a>     }
<a class="jxr_linenumber" name="355" href="#355">355</a> 
<a class="jxr_linenumber" name="356" href="#356">356</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> SSLContext createDefaultSSLContext() <strong class="jxr_keyword">throws</strong> SSLInitializationException {
<a class="jxr_linenumber" name="357" href="#357">357</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="358" href="#358">358</a>             <strong class="jxr_keyword">return</strong> createSSLContext(TLS, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="359" href="#359">359</a>         } <strong class="jxr_keyword">catch</strong> (Exception ex) {
<a class="jxr_linenumber" name="360" href="#360">360</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLInitializationException.html">SSLInitializationException</a>(<span class="jxr_string">"Failure initializing default SSL context"</span>, ex);
<a class="jxr_linenumber" name="361" href="#361">361</a>         }
<a class="jxr_linenumber" name="362" href="#362">362</a>     }
<a class="jxr_linenumber" name="363" href="#363">363</a> 
<a class="jxr_linenumber" name="364" href="#364">364</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> SSLContext createSystemSSLContext() <strong class="jxr_keyword">throws</strong> SSLInitializationException {
<a class="jxr_linenumber" name="365" href="#365">365</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="366" href="#366">366</a>             <strong class="jxr_keyword">return</strong> createSystemSSLContext(TLS, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="367" href="#367">367</a>         } <strong class="jxr_keyword">catch</strong> (Exception ex) {
<a class="jxr_linenumber" name="368" href="#368">368</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLInitializationException.html">SSLInitializationException</a>(<span class="jxr_string">"Failure initializing default system SSL context"</span>, ex);
<a class="jxr_linenumber" name="369" href="#369">369</a>         }
<a class="jxr_linenumber" name="370" href="#370">370</a>     }
<a class="jxr_linenumber" name="371" href="#371">371</a> 
<a class="jxr_linenumber" name="372" href="#372">372</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="373" href="#373">373</a> <em class="jxr_javadoccomment">     * @deprecated Use {@link #SSLSocketFactory(String, KeyStore, String, KeyStore, SecureRandom, X509HostnameVerifier)}</em>
<a class="jxr_linenumber" name="374" href="#374">374</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="375" href="#375">375</a>     @Deprecated
<a class="jxr_linenumber" name="376" href="#376">376</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="377" href="#377">377</a>             <strong class="jxr_keyword">final</strong> String algorithm,
<a class="jxr_linenumber" name="378" href="#378">378</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="379" href="#379">379</a>             <strong class="jxr_keyword">final</strong> String keystorePassword,
<a class="jxr_linenumber" name="380" href="#380">380</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore,
<a class="jxr_linenumber" name="381" href="#381">381</a>             <strong class="jxr_keyword">final</strong> SecureRandom random,
<a class="jxr_linenumber" name="382" href="#382">382</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/scheme/HostNameResolver.html">HostNameResolver</a> nameResolver)
<a class="jxr_linenumber" name="383" href="#383">383</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="384" href="#384">384</a>         <strong class="jxr_keyword">this</strong>(createSSLContext(
<a class="jxr_linenumber" name="385" href="#385">385</a>                 algorithm, keystore, keystorePassword, truststore, random, <strong class="jxr_keyword">null</strong>),
<a class="jxr_linenumber" name="386" href="#386">386</a>                 nameResolver);
<a class="jxr_linenumber" name="387" href="#387">387</a>     }
<a class="jxr_linenumber" name="388" href="#388">388</a> 
<a class="jxr_linenumber" name="389" href="#389">389</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="390" href="#390">390</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="391" href="#391">391</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="392" href="#392">392</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="393" href="#393">393</a>             String algorithm,
<a class="jxr_linenumber" name="394" href="#394">394</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="395" href="#395">395</a>             <strong class="jxr_keyword">final</strong> String keystorePassword,
<a class="jxr_linenumber" name="396" href="#396">396</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore,
<a class="jxr_linenumber" name="397" href="#397">397</a>             <strong class="jxr_keyword">final</strong> SecureRandom random,
<a class="jxr_linenumber" name="398" href="#398">398</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier)
<a class="jxr_linenumber" name="399" href="#399">399</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="400" href="#400">400</a>         <strong class="jxr_keyword">this</strong>(createSSLContext(
<a class="jxr_linenumber" name="401" href="#401">401</a>                 algorithm, keystore, keystorePassword, truststore, random, <strong class="jxr_keyword">null</strong>),
<a class="jxr_linenumber" name="402" href="#402">402</a>                 hostnameVerifier);
<a class="jxr_linenumber" name="403" href="#403">403</a>     }
<a class="jxr_linenumber" name="404" href="#404">404</a> 
<a class="jxr_linenumber" name="405" href="#405">405</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="406" href="#406">406</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="407" href="#407">407</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="408" href="#408">408</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="409" href="#409">409</a>             String algorithm,
<a class="jxr_linenumber" name="410" href="#410">410</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="411" href="#411">411</a>             <strong class="jxr_keyword">final</strong> String keystorePassword,
<a class="jxr_linenumber" name="412" href="#412">412</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore,
<a class="jxr_linenumber" name="413" href="#413">413</a>             <strong class="jxr_keyword">final</strong> SecureRandom random,
<a class="jxr_linenumber" name="414" href="#414">414</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/TrustStrategy.html">TrustStrategy</a> trustStrategy,
<a class="jxr_linenumber" name="415" href="#415">415</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier)
<a class="jxr_linenumber" name="416" href="#416">416</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="417" href="#417">417</a>         <strong class="jxr_keyword">this</strong>(createSSLContext(
<a class="jxr_linenumber" name="418" href="#418">418</a>                 algorithm, keystore, keystorePassword, truststore, random, trustStrategy),
<a class="jxr_linenumber" name="419" href="#419">419</a>                 hostnameVerifier);
<a class="jxr_linenumber" name="420" href="#420">420</a>     }
<a class="jxr_linenumber" name="421" href="#421">421</a> 
<a class="jxr_linenumber" name="422" href="#422">422</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="423" href="#423">423</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="424" href="#424">424</a>             <strong class="jxr_keyword">final</strong> String keystorePassword,
<a class="jxr_linenumber" name="425" href="#425">425</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore)
<a class="jxr_linenumber" name="426" href="#426">426</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="427" href="#427">427</a>         <strong class="jxr_keyword">this</strong>(TLS, keystore, keystorePassword, truststore, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
<a class="jxr_linenumber" name="428" href="#428">428</a>     }
<a class="jxr_linenumber" name="429" href="#429">429</a> 
<a class="jxr_linenumber" name="430" href="#430">430</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="431" href="#431">431</a>             <strong class="jxr_keyword">final</strong> KeyStore keystore,
<a class="jxr_linenumber" name="432" href="#432">432</a>             <strong class="jxr_keyword">final</strong> String keystorePassword)
<a class="jxr_linenumber" name="433" href="#433">433</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException{
<a class="jxr_linenumber" name="434" href="#434">434</a>         <strong class="jxr_keyword">this</strong>(TLS, keystore, keystorePassword, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
<a class="jxr_linenumber" name="435" href="#435">435</a>     }
<a class="jxr_linenumber" name="436" href="#436">436</a> 
<a class="jxr_linenumber" name="437" href="#437">437</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="438" href="#438">438</a>             <strong class="jxr_keyword">final</strong> KeyStore truststore)
<a class="jxr_linenumber" name="439" href="#439">439</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="440" href="#440">440</a>         <strong class="jxr_keyword">this</strong>(TLS, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, truststore, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
<a class="jxr_linenumber" name="441" href="#441">441</a>     }
<a class="jxr_linenumber" name="442" href="#442">442</a> 
<a class="jxr_linenumber" name="443" href="#443">443</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="444" href="#444">444</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="445" href="#445">445</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="446" href="#446">446</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="447" href="#447">447</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/TrustStrategy.html">TrustStrategy</a> trustStrategy,
<a class="jxr_linenumber" name="448" href="#448">448</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier)
<a class="jxr_linenumber" name="449" href="#449">449</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="450" href="#450">450</a>         <strong class="jxr_keyword">this</strong>(TLS, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, trustStrategy, hostnameVerifier);
<a class="jxr_linenumber" name="451" href="#451">451</a>     }
<a class="jxr_linenumber" name="452" href="#452">452</a> 
<a class="jxr_linenumber" name="453" href="#453">453</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="454" href="#454">454</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="455" href="#455">455</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="456" href="#456">456</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="457" href="#457">457</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/TrustStrategy.html">TrustStrategy</a> trustStrategy)
<a class="jxr_linenumber" name="458" href="#458">458</a>                 <strong class="jxr_keyword">throws</strong> NoSuchAlgorithmException, KeyManagementException, KeyStoreException, UnrecoverableKeyException {
<a class="jxr_linenumber" name="459" href="#459">459</a>         <strong class="jxr_keyword">this</strong>(TLS, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, trustStrategy, BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
<a class="jxr_linenumber" name="460" href="#460">460</a>     }
<a class="jxr_linenumber" name="461" href="#461">461</a> 
<a class="jxr_linenumber" name="462" href="#462">462</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(<strong class="jxr_keyword">final</strong> SSLContext sslContext) {
<a class="jxr_linenumber" name="463" href="#463">463</a>         <strong class="jxr_keyword">this</strong>(sslContext, BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
<a class="jxr_linenumber" name="464" href="#464">464</a>     }
<a class="jxr_linenumber" name="465" href="#465">465</a> 
<a class="jxr_linenumber" name="466" href="#466">466</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="467" href="#467">467</a> <em class="jxr_javadoccomment">     * @deprecated Use {@link #SSLSocketFactory(SSLContext)}</em>
<a class="jxr_linenumber" name="468" href="#468">468</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="469" href="#469">469</a>     @Deprecated
<a class="jxr_linenumber" name="470" href="#470">470</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="471" href="#471">471</a>             <strong class="jxr_keyword">final</strong> SSLContext sslContext, <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/scheme/HostNameResolver.html">HostNameResolver</a> nameResolver) {
<a class="jxr_linenumber" name="472" href="#472">472</a>         <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="473" href="#473">473</a>         <strong class="jxr_keyword">this</strong>.socketfactory = sslContext.getSocketFactory();
<a class="jxr_linenumber" name="474" href="#474">474</a>         <strong class="jxr_keyword">this</strong>.hostnameVerifier = BROWSER_COMPATIBLE_HOSTNAME_VERIFIER;
<a class="jxr_linenumber" name="475" href="#475">475</a>         <strong class="jxr_keyword">this</strong>.nameResolver = nameResolver;
<a class="jxr_linenumber" name="476" href="#476">476</a>     }
<a class="jxr_linenumber" name="477" href="#477">477</a> 
<a class="jxr_linenumber" name="478" href="#478">478</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="479" href="#479">479</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="480" href="#480">480</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="481" href="#481">481</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="482" href="#482">482</a>             <strong class="jxr_keyword">final</strong> SSLContext sslContext, <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier) {
<a class="jxr_linenumber" name="483" href="#483">483</a>         <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="484" href="#484">484</a>         <strong class="jxr_keyword">if</strong> (sslContext == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="485" href="#485">485</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"SSL context may not be null"</span>);
<a class="jxr_linenumber" name="486" href="#486">486</a>         }
<a class="jxr_linenumber" name="487" href="#487">487</a>         <strong class="jxr_keyword">this</strong>.socketfactory = sslContext.getSocketFactory();
<a class="jxr_linenumber" name="488" href="#488">488</a>         <strong class="jxr_keyword">this</strong>.hostnameVerifier = hostnameVerifier;
<a class="jxr_linenumber" name="489" href="#489">489</a>         <strong class="jxr_keyword">this</strong>.nameResolver = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="490" href="#490">490</a>     }
<a class="jxr_linenumber" name="491" href="#491">491</a> 
<a class="jxr_linenumber" name="492" href="#492">492</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="493" href="#493">493</a> <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="494" href="#494">494</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="495" href="#495">495</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/SSLSocketFactory.html">SSLSocketFactory</a>(
<a class="jxr_linenumber" name="496" href="#496">496</a>             <strong class="jxr_keyword">final</strong> javax.net.ssl.SSLSocketFactory socketfactory, 
<a class="jxr_linenumber" name="497" href="#497">497</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier) {
<a class="jxr_linenumber" name="498" href="#498">498</a>         <strong class="jxr_keyword">if</strong> (socketfactory == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="499" href="#499">499</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"SSL socket factory may not be null"</span>);
<a class="jxr_linenumber" name="500" href="#500">500</a>         }
<a class="jxr_linenumber" name="501" href="#501">501</a>         <strong class="jxr_keyword">this</strong>.socketfactory = socketfactory;
<a class="jxr_linenumber" name="502" href="#502">502</a>         <strong class="jxr_keyword">this</strong>.hostnameVerifier = hostnameVerifier;
<a class="jxr_linenumber" name="503" href="#503">503</a>         <strong class="jxr_keyword">this</strong>.nameResolver = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="504" href="#504">504</a>     }
<a class="jxr_linenumber" name="505" href="#505">505</a> 
<a class="jxr_linenumber" name="506" href="#506">506</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="507" href="#507">507</a> <em class="jxr_javadoccomment">     * @param params Optional parameters. Parameters passed to this method will have no effect.</em>
<a class="jxr_linenumber" name="508" href="#508">508</a> <em class="jxr_javadoccomment">     *               This method will create a unconnected instance of {@link Socket} class.</em>
<a class="jxr_linenumber" name="509" href="#509">509</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="510" href="#510">510</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="511" href="#511">511</a>     <strong class="jxr_keyword">public</strong> Socket createSocket(<strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="512" href="#512">512</a>         SSLSocket sock = (SSLSocket) <strong class="jxr_keyword">this</strong>.socketfactory.createSocket();
<a class="jxr_linenumber" name="513" href="#513">513</a>         prepareSocket(sock);
<a class="jxr_linenumber" name="514" href="#514">514</a>         <strong class="jxr_keyword">return</strong> sock;
<a class="jxr_linenumber" name="515" href="#515">515</a>     }
<a class="jxr_linenumber" name="516" href="#516">516</a> 
<a class="jxr_linenumber" name="517" href="#517">517</a>     @Deprecated
<a class="jxr_linenumber" name="518" href="#518">518</a>     <strong class="jxr_keyword">public</strong> Socket createSocket() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="519" href="#519">519</a>         SSLSocket sock = (SSLSocket) <strong class="jxr_keyword">this</strong>.socketfactory.createSocket();
<a class="jxr_linenumber" name="520" href="#520">520</a>         prepareSocket(sock);
<a class="jxr_linenumber" name="521" href="#521">521</a>         <strong class="jxr_keyword">return</strong> sock;
<a class="jxr_linenumber" name="522" href="#522">522</a>     }
<a class="jxr_linenumber" name="523" href="#523">523</a> 
<a class="jxr_linenumber" name="524" href="#524">524</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="525" href="#525">525</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="526" href="#526">526</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="527" href="#527">527</a>     <strong class="jxr_keyword">public</strong> Socket connectSocket(
<a class="jxr_linenumber" name="528" href="#528">528</a>             <strong class="jxr_keyword">final</strong> Socket socket,
<a class="jxr_linenumber" name="529" href="#529">529</a>             <strong class="jxr_keyword">final</strong> InetSocketAddress remoteAddress,
<a class="jxr_linenumber" name="530" href="#530">530</a>             <strong class="jxr_keyword">final</strong> InetSocketAddress localAddress,
<a class="jxr_linenumber" name="531" href="#531">531</a>             <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> IOException, UnknownHostException, ConnectTimeoutException {
<a class="jxr_linenumber" name="532" href="#532">532</a>         <strong class="jxr_keyword">if</strong> (remoteAddress == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="533" href="#533">533</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Remote address may not be null"</span>);
<a class="jxr_linenumber" name="534" href="#534">534</a>         }
<a class="jxr_linenumber" name="535" href="#535">535</a>         <strong class="jxr_keyword">if</strong> (params == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="536" href="#536">536</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"HTTP parameters may not be null"</span>);
<a class="jxr_linenumber" name="537" href="#537">537</a>         }
<a class="jxr_linenumber" name="538" href="#538">538</a>         Socket sock = socket != <strong class="jxr_keyword">null</strong> ? socket : <strong class="jxr_keyword">this</strong>.socketfactory.createSocket();
<a class="jxr_linenumber" name="539" href="#539">539</a>         <strong class="jxr_keyword">if</strong> (localAddress != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="540" href="#540">540</a>             sock.setReuseAddress(HttpConnectionParams.getSoReuseaddr(params));
<a class="jxr_linenumber" name="541" href="#541">541</a>             sock.bind(localAddress);
<a class="jxr_linenumber" name="542" href="#542">542</a>         }
<a class="jxr_linenumber" name="543" href="#543">543</a> 
<a class="jxr_linenumber" name="544" href="#544">544</a>         <strong class="jxr_keyword">int</strong> connTimeout = HttpConnectionParams.getConnectionTimeout(params);
<a class="jxr_linenumber" name="545" href="#545">545</a>         <strong class="jxr_keyword">int</strong> soTimeout = HttpConnectionParams.getSoTimeout(params);
<a class="jxr_linenumber" name="546" href="#546">546</a> 
<a class="jxr_linenumber" name="547" href="#547">547</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="548" href="#548">548</a>             sock.setSoTimeout(soTimeout);
<a class="jxr_linenumber" name="549" href="#549">549</a>             sock.connect(remoteAddress, connTimeout);
<a class="jxr_linenumber" name="550" href="#550">550</a>         } <strong class="jxr_keyword">catch</strong> (SocketTimeoutException ex) {
<a class="jxr_linenumber" name="551" href="#551">551</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/ConnectTimeoutException.html">ConnectTimeoutException</a>(<span class="jxr_string">"Connect to "</span> + remoteAddress + <span class="jxr_string">" timed out"</span>);
<a class="jxr_linenumber" name="552" href="#552">552</a>         }
<a class="jxr_linenumber" name="553" href="#553">553</a> 
<a class="jxr_linenumber" name="554" href="#554">554</a>         String hostname;
<a class="jxr_linenumber" name="555" href="#555">555</a>         <strong class="jxr_keyword">if</strong> (remoteAddress instanceof HttpInetSocketAddress) {
<a class="jxr_linenumber" name="556" href="#556">556</a>             hostname = ((HttpInetSocketAddress) remoteAddress).getHttpHost().getHostName();
<a class="jxr_linenumber" name="557" href="#557">557</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="558" href="#558">558</a>             hostname = remoteAddress.getHostName();
<a class="jxr_linenumber" name="559" href="#559">559</a>         }
<a class="jxr_linenumber" name="560" href="#560">560</a> 
<a class="jxr_linenumber" name="561" href="#561">561</a>         SSLSocket sslsock;
<a class="jxr_linenumber" name="562" href="#562">562</a>         <em class="jxr_comment">// Setup SSL layering if necessary</em>
<a class="jxr_linenumber" name="563" href="#563">563</a>         <strong class="jxr_keyword">if</strong> (sock instanceof SSLSocket) {
<a class="jxr_linenumber" name="564" href="#564">564</a>             sslsock = (SSLSocket) sock;
<a class="jxr_linenumber" name="565" href="#565">565</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="566" href="#566">566</a>             <strong class="jxr_keyword">int</strong> port = remoteAddress.getPort();
<a class="jxr_linenumber" name="567" href="#567">567</a>             sslsock = (SSLSocket) <strong class="jxr_keyword">this</strong>.socketfactory.createSocket(sock, hostname, port, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="568" href="#568">568</a>             prepareSocket(sslsock);
<a class="jxr_linenumber" name="569" href="#569">569</a>         }
<a class="jxr_linenumber" name="570" href="#570">570</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.hostnameVerifier != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="571" href="#571">571</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="572" href="#572">572</a>                 <strong class="jxr_keyword">this</strong>.hostnameVerifier.verify(hostname, sslsock);
<a class="jxr_linenumber" name="573" href="#573">573</a>                 <em class="jxr_comment">// verifyHostName() didn't blowup - good!</em>
<a class="jxr_linenumber" name="574" href="#574">574</a>             } <strong class="jxr_keyword">catch</strong> (IOException iox) {
<a class="jxr_linenumber" name="575" href="#575">575</a>                 <em class="jxr_comment">// close the socket before re-throwing the exception</em>
<a class="jxr_linenumber" name="576" href="#576">576</a>                 <strong class="jxr_keyword">try</strong> { sslsock.close(); } <strong class="jxr_keyword">catch</strong> (Exception x) { <em class="jxr_comment">/*<em class="jxr_comment">ignore*/</em> }</em>
<a class="jxr_linenumber" name="577" href="#577">577</a>                 <strong class="jxr_keyword">throw</strong> iox;
<a class="jxr_linenumber" name="578" href="#578">578</a>             }
<a class="jxr_linenumber" name="579" href="#579">579</a>         }
<a class="jxr_linenumber" name="580" href="#580">580</a>         <strong class="jxr_keyword">return</strong> sslsock;
<a class="jxr_linenumber" name="581" href="#581">581</a>     }
<a class="jxr_linenumber" name="582" href="#582">582</a> 
<a class="jxr_linenumber" name="583" href="#583">583</a> 
<a class="jxr_linenumber" name="584" href="#584">584</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="585" href="#585">585</a> <em class="jxr_javadoccomment">     * Checks whether a socket connection is secure.</em>
<a class="jxr_linenumber" name="586" href="#586">586</a> <em class="jxr_javadoccomment">     * This factory creates TLS/SSL socket connections</em>
<a class="jxr_linenumber" name="587" href="#587">587</a> <em class="jxr_javadoccomment">     * which, by default, are considered secure.</em>
<a class="jxr_linenumber" name="588" href="#588">588</a> <em class="jxr_javadoccomment">     * &lt;br/&gt;</em>
<a class="jxr_linenumber" name="589" href="#589">589</a> <em class="jxr_javadoccomment">     * Derived classes may override this method to perform</em>
<a class="jxr_linenumber" name="590" href="#590">590</a> <em class="jxr_javadoccomment">     * runtime checks, for example based on the cypher suite.</em>
<a class="jxr_linenumber" name="591" href="#591">591</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="592" href="#592">592</a> <em class="jxr_javadoccomment">     * @param sock      the connected socket</em>
<a class="jxr_linenumber" name="593" href="#593">593</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="594" href="#594">594</a> <em class="jxr_javadoccomment">     * @return  &lt;code&gt;true&lt;/code&gt;</em>
<a class="jxr_linenumber" name="595" href="#595">595</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="596" href="#596">596</a> <em class="jxr_javadoccomment">     * @throws IllegalArgumentException if the argument is invalid</em>
<a class="jxr_linenumber" name="597" href="#597">597</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="598" href="#598">598</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isSecure(<strong class="jxr_keyword">final</strong> Socket sock) <strong class="jxr_keyword">throws</strong> IllegalArgumentException {
<a class="jxr_linenumber" name="599" href="#599">599</a>         <strong class="jxr_keyword">if</strong> (sock == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="600" href="#600">600</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Socket may not be null"</span>);
<a class="jxr_linenumber" name="601" href="#601">601</a>         }
<a class="jxr_linenumber" name="602" href="#602">602</a>         <em class="jxr_comment">// This instanceof check is in line with createSocket() above.</em>
<a class="jxr_linenumber" name="603" href="#603">603</a>         <strong class="jxr_keyword">if</strong> (!(sock instanceof SSLSocket)) {
<a class="jxr_linenumber" name="604" href="#604">604</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Socket not created by this factory"</span>);
<a class="jxr_linenumber" name="605" href="#605">605</a>         }
<a class="jxr_linenumber" name="606" href="#606">606</a>         <em class="jxr_comment">// This check is performed last since it calls the argument object.</em>
<a class="jxr_linenumber" name="607" href="#607">607</a>         <strong class="jxr_keyword">if</strong> (sock.isClosed()) {
<a class="jxr_linenumber" name="608" href="#608">608</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Socket is closed"</span>);
<a class="jxr_linenumber" name="609" href="#609">609</a>         }
<a class="jxr_linenumber" name="610" href="#610">610</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="611" href="#611">611</a>     }
<a class="jxr_linenumber" name="612" href="#612">612</a> 
<a class="jxr_linenumber" name="613" href="#613">613</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="614" href="#614">614</a> <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="615" href="#615">615</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="616" href="#616">616</a>     <strong class="jxr_keyword">public</strong> Socket createLayeredSocket(
<a class="jxr_linenumber" name="617" href="#617">617</a>         <strong class="jxr_keyword">final</strong> Socket socket,
<a class="jxr_linenumber" name="618" href="#618">618</a>         <strong class="jxr_keyword">final</strong> String host,
<a class="jxr_linenumber" name="619" href="#619">619</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> port,
<a class="jxr_linenumber" name="620" href="#620">620</a>         <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> IOException, UnknownHostException {
<a class="jxr_linenumber" name="621" href="#621">621</a>         SSLSocket sslSocket = (SSLSocket) <strong class="jxr_keyword">this</strong>.socketfactory.createSocket(
<a class="jxr_linenumber" name="622" href="#622">622</a>               socket,
<a class="jxr_linenumber" name="623" href="#623">623</a>               host,
<a class="jxr_linenumber" name="624" href="#624">624</a>               port,
<a class="jxr_linenumber" name="625" href="#625">625</a>               <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="626" href="#626">626</a>         prepareSocket(sslSocket);
<a class="jxr_linenumber" name="627" href="#627">627</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.hostnameVerifier != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="628" href="#628">628</a>             <strong class="jxr_keyword">this</strong>.hostnameVerifier.verify(host, sslSocket);
<a class="jxr_linenumber" name="629" href="#629">629</a>         }
<a class="jxr_linenumber" name="630" href="#630">630</a>         <em class="jxr_comment">// verifyHostName() didn't blowup - good!</em>
<a class="jxr_linenumber" name="631" href="#631">631</a>         <strong class="jxr_keyword">return</strong> sslSocket;
<a class="jxr_linenumber" name="632" href="#632">632</a>     }
<a class="jxr_linenumber" name="633" href="#633">633</a> 
<a class="jxr_linenumber" name="634" href="#634">634</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="635" href="#635">635</a> <em class="jxr_javadoccomment">     * @deprecated use {@link #createLayeredSocket(Socket, String, int, HttpParams)}</em>
<a class="jxr_linenumber" name="636" href="#636">636</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="637" href="#637">637</a>     <strong class="jxr_keyword">public</strong> Socket createLayeredSocket(
<a class="jxr_linenumber" name="638" href="#638">638</a>         <strong class="jxr_keyword">final</strong> Socket socket,
<a class="jxr_linenumber" name="639" href="#639">639</a>         <strong class="jxr_keyword">final</strong> String host,
<a class="jxr_linenumber" name="640" href="#640">640</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> port,
<a class="jxr_linenumber" name="641" href="#641">641</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> autoClose) <strong class="jxr_keyword">throws</strong> IOException, UnknownHostException {
<a class="jxr_linenumber" name="642" href="#642">642</a>         SSLSocket sslSocket = (SSLSocket) <strong class="jxr_keyword">this</strong>.socketfactory.createSocket(
<a class="jxr_linenumber" name="643" href="#643">643</a>               socket,
<a class="jxr_linenumber" name="644" href="#644">644</a>               host,
<a class="jxr_linenumber" name="645" href="#645">645</a>               port,
<a class="jxr_linenumber" name="646" href="#646">646</a>               autoClose
<a class="jxr_linenumber" name="647" href="#647">647</a>         );
<a class="jxr_linenumber" name="648" href="#648">648</a>         prepareSocket(sslSocket);
<a class="jxr_linenumber" name="649" href="#649">649</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.hostnameVerifier != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="650" href="#650">650</a>             <strong class="jxr_keyword">this</strong>.hostnameVerifier.verify(host, sslSocket);
<a class="jxr_linenumber" name="651" href="#651">651</a>         }
<a class="jxr_linenumber" name="652" href="#652">652</a>         <em class="jxr_comment">// verifyHostName() didn't blowup - good!</em>
<a class="jxr_linenumber" name="653" href="#653">653</a>         <strong class="jxr_keyword">return</strong> sslSocket;
<a class="jxr_linenumber" name="654" href="#654">654</a>     }
<a class="jxr_linenumber" name="655" href="#655">655</a> 
<a class="jxr_linenumber" name="656" href="#656">656</a>     @Deprecated
<a class="jxr_linenumber" name="657" href="#657">657</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHostnameVerifier(<a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> hostnameVerifier) {
<a class="jxr_linenumber" name="658" href="#658">658</a>         <strong class="jxr_keyword">if</strong> ( hostnameVerifier == <strong class="jxr_keyword">null</strong> ) {
<a class="jxr_linenumber" name="659" href="#659">659</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Hostname verifier may not be null"</span>);
<a class="jxr_linenumber" name="660" href="#660">660</a>         }
<a class="jxr_linenumber" name="661" href="#661">661</a>         <strong class="jxr_keyword">this</strong>.hostnameVerifier = hostnameVerifier;
<a class="jxr_linenumber" name="662" href="#662">662</a>     }
<a class="jxr_linenumber" name="663" href="#663">663</a> 
<a class="jxr_linenumber" name="664" href="#664">664</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> getHostnameVerifier() {
<a class="jxr_linenumber" name="665" href="#665">665</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.hostnameVerifier;
<a class="jxr_linenumber" name="666" href="#666">666</a>     }
<a class="jxr_linenumber" name="667" href="#667">667</a> 
<a class="jxr_linenumber" name="668" href="#668">668</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="669" href="#669">669</a> <em class="jxr_javadoccomment">     * @deprecated Use {@link #connectSocket(Socket, InetSocketAddress, InetSocketAddress, HttpParams)}</em>
<a class="jxr_linenumber" name="670" href="#670">670</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="671" href="#671">671</a>     @Deprecated
<a class="jxr_linenumber" name="672" href="#672">672</a>     <strong class="jxr_keyword">public</strong> Socket connectSocket(
<a class="jxr_linenumber" name="673" href="#673">673</a>             <strong class="jxr_keyword">final</strong> Socket socket,
<a class="jxr_linenumber" name="674" href="#674">674</a>             <strong class="jxr_keyword">final</strong> String host, <strong class="jxr_keyword">int</strong> port,
<a class="jxr_linenumber" name="675" href="#675">675</a>             <strong class="jxr_keyword">final</strong> InetAddress localAddress, <strong class="jxr_keyword">int</strong> localPort,
<a class="jxr_linenumber" name="676" href="#676">676</a>             <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> IOException, UnknownHostException, ConnectTimeoutException {
<a class="jxr_linenumber" name="677" href="#677">677</a>         InetSocketAddress local = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="678" href="#678">678</a>         <strong class="jxr_keyword">if</strong> (localAddress != <strong class="jxr_keyword">null</strong> || localPort &gt; 0) {
<a class="jxr_linenumber" name="679" href="#679">679</a>             <em class="jxr_comment">// we need to bind explicitly</em>
<a class="jxr_linenumber" name="680" href="#680">680</a>             <strong class="jxr_keyword">if</strong> (localPort &lt; 0) {
<a class="jxr_linenumber" name="681" href="#681">681</a>                 localPort = 0; <em class="jxr_comment">// indicates "any"</em>
<a class="jxr_linenumber" name="682" href="#682">682</a>             }
<a class="jxr_linenumber" name="683" href="#683">683</a>             local = <strong class="jxr_keyword">new</strong> InetSocketAddress(localAddress, localPort);
<a class="jxr_linenumber" name="684" href="#684">684</a>         }
<a class="jxr_linenumber" name="685" href="#685">685</a>         InetAddress remoteAddress;
<a class="jxr_linenumber" name="686" href="#686">686</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.nameResolver != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="687" href="#687">687</a>             remoteAddress = <strong class="jxr_keyword">this</strong>.nameResolver.resolve(host);
<a class="jxr_linenumber" name="688" href="#688">688</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="689" href="#689">689</a>             remoteAddress = InetAddress.getByName(host);
<a class="jxr_linenumber" name="690" href="#690">690</a>         }
<a class="jxr_linenumber" name="691" href="#691">691</a>         InetSocketAddress remote = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/conn/HttpInetSocketAddress.html">HttpInetSocketAddress</a>(<strong class="jxr_keyword">new</strong> HttpHost(host, port), remoteAddress, port);
<a class="jxr_linenumber" name="692" href="#692">692</a>         <strong class="jxr_keyword">return</strong> connectSocket(socket, remote, local, params);
<a class="jxr_linenumber" name="693" href="#693">693</a>     }
<a class="jxr_linenumber" name="694" href="#694">694</a> 
<a class="jxr_linenumber" name="695" href="#695">695</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="696" href="#696">696</a> <em class="jxr_javadoccomment">     * @deprecated Use {@link #createLayeredSocket(Socket, String, int, boolean)}</em>
<a class="jxr_linenumber" name="697" href="#697">697</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="698" href="#698">698</a>     @Deprecated
<a class="jxr_linenumber" name="699" href="#699">699</a>     <strong class="jxr_keyword">public</strong> Socket createSocket(
<a class="jxr_linenumber" name="700" href="#700">700</a>             <strong class="jxr_keyword">final</strong> Socket socket,
<a class="jxr_linenumber" name="701" href="#701">701</a>             <strong class="jxr_keyword">final</strong> String host, <strong class="jxr_keyword">int</strong> port,
<a class="jxr_linenumber" name="702" href="#702">702</a>             <strong class="jxr_keyword">boolean</strong> autoClose) <strong class="jxr_keyword">throws</strong> IOException, UnknownHostException {
<a class="jxr_linenumber" name="703" href="#703">703</a>         <strong class="jxr_keyword">return</strong> createLayeredSocket(socket, host, port, autoClose);
<a class="jxr_linenumber" name="704" href="#704">704</a>     }
<a class="jxr_linenumber" name="705" href="#705">705</a> 
<a class="jxr_linenumber" name="706" href="#706">706</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="707" href="#707">707</a> <em class="jxr_javadoccomment">     * Performs any custom initialization for a newly created SSLSocket</em>
<a class="jxr_linenumber" name="708" href="#708">708</a> <em class="jxr_javadoccomment">     * (before the SSL handshake happens).</em>
<a class="jxr_linenumber" name="709" href="#709">709</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="710" href="#710">710</a> <em class="jxr_javadoccomment">     * The default implementation is a no-op, but could be overriden to, e.g.,</em>
<a class="jxr_linenumber" name="711" href="#711">711</a> <em class="jxr_javadoccomment">     * call {@link SSLSocket#setEnabledCipherSuites(java.lang.String[])}.</em>
<a class="jxr_linenumber" name="712" href="#712">712</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="713" href="#713">713</a> <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="714" href="#714">714</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="715" href="#715">715</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> prepareSocket(<strong class="jxr_keyword">final</strong> SSLSocket socket) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="716" href="#716">716</a>     }
<a class="jxr_linenumber" name="717" href="#717">717</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

